#ifndef _sn76489_H_
#define _sn76489_H_

#include <Arduino.h>

/** Macro for frequency register */
#define FREG_REG_VAL(f) (4000000UL / 32 / (f))

/* Register values */
#define ATTENUATION_2DB (1)
#define ATTENUATION_4DB (2)
#define ATTENUATION_8DB (4)
#define ATTENUATION_16DB (8)
#define ATTENUATION_OFF (15)

/* Noise controls */
#define NOISE_PERIODIC_FEEDBACK (0)
#define NOISE_WHITE_FEEDBACK (1 << 2)
#define NOISE_SHIFT_512 (0)
#define NOISE_SHIFT_1024 (1)
#define NOISE_SHIFT_2048 (2)
#define NOISE_SHIFT_TONE3 (3)

class sn76489 {
  public:
    sn76489( byte we, byte ce, byte rdy );
    void init();
    void setReg( uint8_t reg, uint8_t data );
    void setFreq( uint8_t channel, uint16_t frequency );
    void test();
    void ping();
  private:
    void _send( byte data );
    byte _we;
    byte _ce;
    byte _rdy;
};

#endif /* _sn76489_H_ */
